A题 http://codeforces.com/problemset/problem/699/A

非常的水,两个相向而行,且间距最小的点,搜一遍就是答案了。

 #include <cstdio>
 #include <algorithm>
 using namespace std;
 struct node
 {
     int x;char ch;
 }s[+];
 bool cmp(node& a,node& b)
 {
     return a.x<b.x;
 }
 int main()
 {
     int n;
     while(~scanf("%d",&n))
     {
         getchar();
         ;i<n;i++)
             scanf("%c",&s[i].ch);
         ;i<n;i++)
             scanf("%d",&s[i].x);
         sort(s,s+n,cmp);
         int ans = 0x3f3f3f3f;
         ;i<n;i++)
         {
             ].ch == 'R')
             {
                 ].x)/;
                 ans = min(ans,dis);
             }
         }
         if(ans == 0x3f3f3f3f)
             printf("-1\n");
         else
             printf("%d\n",ans);
     }
     ;
 }

B题 http://codeforces.com/problemset/problem/699/B

讲道理 也是水题 然而我在实现的时候 实现不好这个问题 然而梦天2333 毕竟天神啪啪啪随便写写就A了。

这个代码是参考网上的思路搞的,关键是一个V数组和一个C数组记录,行和列的情况。

还有读入字符串的时候要小心的,因为它题目中默认的地图是从1开始的,如果直接scanf ma[i]这样读进来 就是每行都从0开始了,和题意不符

 scanf();//输入的一个小技巧

其实思路和它标程是一样的,就是没码出来。

 #include <cstdio>
 #include <cstring>
 #define mem0(x) memset(x,0,sizeof(x))
 ][];
 ],C[];
 int tot,fi,fj,n,m;
 bool judge()
 {
     ;i<=n;i++)
     {
         ;j<=m;j++)
         {
             int cur = R[i] + C[j];
             if(ma[i][j] == '*') cur--;
             if(tot == cur)
             {
                 fi = i, fj = j;
                 return true;
             }

         }
     }
     return false;
 }
 int main()
 {
     while(~scanf("%d%d",&n,&m))
     {
         mem0(R);
         mem0(C);
         ;i<=n;i++)
             scanf();//输入的一个小技巧
         tot = ;
         ;i<=n;i++)
             ;j<=m;j++)
                 if(ma[i][j] == '*')
                 {
                     R[i] ++;
                     C[j] ++;
                     tot++;
                 }
         if(judge())
             printf("YES\n%d %d\n",fi,fj);
         else
             printf("NO\n");
     }
     ;
 }

C题 http://codeforces.com/problemset/problem/698/A

dp,小心一下 任何一种情况下都是能选择休息的。

 #include <cstdio>
 #include <map>
 #include <queue>
 #include <cstring>
 #include <algorithm>
 #include <iostream>
 using namespace std;
 #define mem0(x) memset(x,0,sizeof(x))
 #define mem1(x) memset(x,-1,sizeof(x))
 typedef long long LL;
 const int INF = 0x3f3f3f3f;

 int a;
 ][];
 int main()
 {
     int n;
     scanf("%d",&n);
     ;i<=n;i++)
     {
         scanf("%d",&a);
         )
         {
             dp[i][] = max(max(dp[i-][], dp[i-][]), dp[i-][]);
         }
         )
         {
             dp[i][] = max(max(dp[i-][],dp[i-][]),dp[i-][]);
             dp[i][] = max(dp[i-][], dp[i-][]) + ;
         }
         )
         {
             dp[i][] = max(max(dp[i-][],dp[i-][]),dp[i-][]);
             dp[i][] = max(dp[i-][], dp[i-][]) + ;
         }
         else
         {
             dp[i][] = max(max(dp[i-][],dp[i-][]),dp[i-][]);
             dp[i][] = max(dp[i-][], dp[i-][]) + ;
             dp[i][] = max(dp[i-][], dp[i-][]) + ;
         }
     }
     ;
     ;i<;i++)
         maxn = max(maxn, dp[n][i]);
     printf("%d\n",n-maxn);
     ;
 }

D题 http://codeforces.com/problemset/problem/698/B

这题挺难想的当时。先思考整个问题,无非是由若干个环和若干棵树来组成了最初的图。

如果都是树,那么很好解决,选一棵树作为主树,其他的树根直接链接到主树的根上就解决问题了,修改次数应该是根结点的总数目-1。

如果都是环,那么,把某个环的某个结点接到自己身上,形成一棵树之后,其他的环直接接上来就好了。

如果是环和树都有,那么只要把环接到主树上就好了。

 #include <cstdio>
 #include <map>
 #include <queue>
 #include <cstring>
 #include <algorithm>
 #include <iostream>
 using namespace std;
 #define mem0(x) memset(x,0,sizeof(x))
 #define mem1(x) memset(x,-1,sizeof(x))
 typedef long long LL;
 const int INF = 0x3f3f3f3f;

 ];
 ];
 int uf_find(int x)
 {
     if(x==pa[x]) return x;
     return pa[x] = uf_find(pa[x]);
 }

 int main()
 {
     int n,cnt,root;
     scanf("%d",&n);
     //uf_init
     ;i<=n;i++) pa[i] = i ;

     cnt = , root = ;
     ;i<=n;i++)
     {
         scanf("%d",&a[i]);
         if(i == a[i])
         {
             cnt++,root = i;
         }
         else
         {
             int fx = uf_find(i);
             int fy = uf_find(a[i]);
             if(fx == fy)   a[i] = i,cnt++;//成环
             else           pa[fx] = fy;
         }
     }
     )
     {
         ;i<=n;i++)
         {
             if(i == pa[i])
             {
                 root = i;
                 break;
             }
         }
         cnt++;
     }
     printf();
     ;i<=n;i++)
     {
         if(i == a[i]) a[i] = root;//根只能有一个
         printf("%d%c",a[i],i==n?'\n':' ');
     }
     ;
 }

Codeforces Round #363 (Div. 2)的更多相关文章

  1. Codeforces Round 363 Div. 1 (A,B,C,D,E,F)

    Codeforces Round 363 Div. 1 题目链接:## 点击打开链接 A. Vacations (1s, 256MB) 题目大意:给定连续 \(n\) 天,每天为如下四种状态之一: 不 ...

  2. Codeforces Round #363 (Div. 1) B. Fix a Tree 树的拆环

    题目链接:http://codeforces.com/problemset/problem/698/B题意:告诉你n个节点当前的父节点,修改最少的点的父节点使之变成一棵有根树.思路:拆环.题解:htt ...

  3. Codeforces Round #363 (Div. 2) D. Fix a Tree —— 并查集

    题目链接:http://codeforces.com/contest/699/problem/D D. Fix a Tree time limit per test 2 seconds memory ...

  4. Codeforces Round #363 (Div. 2) B. One Bomb —— 技巧

    题目链接:http://codeforces.com/contest/699/problem/B 题解: 首先统计每行每列出现'*'的次数,以及'*'出现的总次数,得到r[n]和c[m]数组,以及su ...

  5. Codeforces Round #363 (Div. 2) C. Vacations —— DP

    题目链接:http://codeforces.com/contest/699/problem/C 题解: 1.可知每天有三个状态:1.contest ,2.gym,3.rest. 2.所以设dp[i] ...

  6. Codeforces Round #363 (Div. 2)A-D

    699A 题意:在一根数轴上有n个东西以相同的速率1m/s在运动,给出他们的坐标以及运动方向,问最快发生的碰撞在什么时候 思路:遍历一遍坐标,看那两个相邻的可能相撞,更新ans #include< ...

  7. Codeforces Round #363 Div.2[111110]

    好久没做手生了,不然前四道都是能A的,当然,正常发挥也是菜. A:Launch of Collider 题意:20万个点排在一条直线上,其坐标均为偶数.从某一时刻开始向左或向右运动,速度为每秒1个单位 ...

  8. Codeforces Round #363 (Div. 2) One Bomb

    One Bomb 题意: 只有一个炸弹,并且一个只能炸一行和一列的'*',问最后能否炸完所以'*',如果可以输出炸弹坐标 题解: 这题做的时候真的没什么好想法,明知道b题应该不难,但只会瞎写,最后越写 ...

  9. Codeforces Round #363 (Div. 2)->C. Vacations

    C. Vacations time limit per test 1 second memory limit per test 256 megabytes input standard input o ...

随机推荐

  1. wpf converter converterparameter 绑定多参数

    1. converterparameter不是依赖属性,所以不能用binding. 2. 可以把converter 的接口 IValueConverter改为 IMultiValueConverter ...

  2. mysql关联表的复制

    1. 复制被参照的表: CREATE TABLE clone_product_1 LIKE product_1; INSERT INTO clone_product_1 SELECT * FROM p ...

  3. rails

    http://ruby-toolbox.com/ ~/.gemrc --- :backtrace: false :benchmark: false :bulk_threshold: 1000 :sou ...

  4. WebStorage的使用

    HTML5中的WebStorage有两种类型的API:localStorage和sessionStorage: localStorage在本地永久性存储数据,除非显式将其删除或清空: sessionS ...

  5. yii2 session的使用方法

    yii2打开session use yii\web\Session; $session = Yii::$app->session; // check if a session is alread ...

  6. 面试题目——《CC150》数学与概率

    面试题7.2:三角形的三个顶点上各有一只蚂蚁.如果蚂蚁开始沿着三角形的边爬行,两只或三只蚂蚁撞到一起的概率有多大?假定每只蚂蚁会随机选一个方向,每个方向被选到的几率相等,而且三只蚂蚁的爬行速度相同. ...

  7. spring mvc统一异常处理(@ControllerAdvice + @ExceptionHandler)

    spring 封装了非常强大的异常处理机制.本文选取@ControllerAdvice + @ExceptionHandler 这种零配置(全注解),作为异常处理解决方案! @ControllerAd ...

  8. mysql [ERROR] Fatal error: Can't open and lock privilege tables: Table 'mysql.host' doesn't exist (转载)

    mysql报错Fatal error: Can't open and lock privilege tables: Table 'mysql.host' doesn't exist 2013-11-2 ...

  9. SQL SERVER 中 GO 的用法

    用信号通知 Microsoft® SQL Server™ 实用工具一批 Transact-SQL 语句的结束.GO 不是 Transact-SQL 语句:而是可为 osql 和 isql 实用工具及 ...

  10. UI第十六节——UITabBarController详解

    一.UITabBarController主要用来管理你提供的content view controllers,而每一个 content view controller则负责管理自己的view层级关系, ...